.global delay4clk
.align 4
delay4clk:
	_addi.n a2, a2, -1
	bnez a2, delay4clk
	_ret.n

  .extern panic

  .begin      literal_prefix .DebugExceptionVector
  .section    .DebugExceptionVector.text, "ax"
  .global     _DebugExceptionVector
  .type       _DebugExceptionVector,@function
  .align      4
_DebugExceptionVector:
  /* never returns here - call0 is used as a jump (see note at top) */
  movi        a2, 1
  j           panic
//  rfe
  .end        literal_prefix

  .begin      literal_prefix .NMIExceptionVector
  .section    .NMIExceptionVector.text, "ax"
  .global     _NMIExceptionVector
  .type       _NMIExceptionVector,@function
  .align      4
_NMIExceptionVector:
  movi        a2, 2
  j           panic
//  rfe
  .end        literal_prefix

  .begin      literal_prefix .KernelExceptionVector
  .section    .KernelExceptionVector.text, "ax"
  .global     _KernelExceptionVector
  .type       _KernelExceptionVector,@function
  .align      4
_KernelExceptionVector:
  _j          _KernelExceptionHandler         /* kernel exception handler */
  .end        literal_prefix

  .begin      literal_prefix .UserExceptionVector
  .section    .UserExceptionVector.text, "ax"
  .global     _UserExceptionVector
  .type       _UserExceptionVector,@function
  .align      4
_UserExceptionVector:
  _j          _UserExceptionHandler           /* user exception handler */
  .end        literal_prefix

  .begin      literal_prefix .DoubleExceptionVector
  .section    .DoubleExceptionVector.text, "ax"
  .global     _DoubleExceptionVector
  .type       _DoubleExceptionVector,@function
  .align      4
_DoubleExceptionVector:
  movi        a2, 3
  j           panic
//  rfe
  .end        literal_prefix

  .section    .text, "ax"

_KernelExceptionHandler:
  movi        a2, 4
  j           panic
1:
  j 1b
  rfe

//  .extern counter0
//  .extern isr_ps
_UserExceptionHandler:
  addi a1, a1, -48

	s32i.n  a2, a1, 0

  rsr     a2, exccause
  beqi    a2, 4, 1f

  movi    a3, 0x3FFE9000  /* store exception cause */
  s32i    a2, a3, 0
  rsr     a0, epc1
  s32i    a0, a3, 4

  movi    a3, 9
//  bgeu    a2, a3, 2f
  beq     a2, a3, 2f

/* exception != 9 */
  movi    a2, 5
  j       panic

/* exception = 9 */
2:
  movi    a2, 10
  j       panic

/* handle timer interrupt */
1:
	s32i.n  a3, a1, 4

  /* update timer */
  rsr     a2, ccount
  movi    a3, 80000
  add     a2, a2, a3
  wsr     a2, ccompare0

  /* save extctx */
	s32i.n  a4, a1, 8
	s32i.n  a5, a1, 12
	s32i.n  a6, a1, 16
	s32i.n  a7, a1, 20
	s32i.n  a8, a1, 24
	s32i.n  a9, a1, 28
	s32i.n  a10, a1, 32
	s32i.n  a11, a1, 36
	rsr     a2, ps
	s32i.n  a2, a1, 40
	s32i.n  a0, a1, 44
/*
  movi    a2, counter0
  l32i    a3, a2, 0
  addi    a3, a3, 1
  s32i    a3, a2, 0

  movi    a2, isr_ps
  rsr     a3, ps
  s32i.n  a3, a2, 0
*/
  rsil    a2, 15

//  .extern func1
//  call0   func1
  .extern chSchIsPreemptionRequired
  .extern chSchDoReschedule
  .extern chSysTimerHandlerI

  call0   chSysTimerHandlerI
  call0   chSchIsPreemptionRequired
  beqz    a2, 1f
  call0   chSchDoReschedule
1:

  /* restore extctx */
	l32i.n  a2, a1, 0
	l32i.n  a3, a1, 4
	l32i.n  a4, a1, 8
	l32i.n  a5, a1, 12
	l32i.n  a6, a1, 16
	l32i.n  a7, a1, 20
	l32i.n  a8, a1, 24
	l32i.n  a9, a1, 28
	l32i.n  a10, a1, 32
	l32i.n  a11, a1, 36
	l32i.n  a0, a1, 40
	wsr     a0, ps
	esync
	l32i.n  a0, a1, 44

  addi    a1, a1, 48
  rfe













/*

//An example function

.global myfunc

myfunc:
	addi a1, a1, -68
	s32i.n a0, a1, 0   // Working reg
	s32i.n a2, a1, 4   // Running byte
	s32i.n a3, a1, 8   // Running CRC
	s32i.n a4, a1, 12  // Anding mask

	movi a0, 320000
	movi a2, PIN_BASE
	l32i a4, a2, 0
keep_going:
	//At 80 MHz, this instruction takes 12 cycles
	//At 160 MHz, this instruction takes 12 cycles
	//At 320 MHz, this instruction takes 16 cycles
	//At 346.6666 MHz, this is 16 cycles.  -> We have 28.8888 cycles

	//l32i a3, a4, 0
	l8ui a3, a2, 0  //1 cycle!!!
	addi a0, a0, -1
	bnez a0, keep_going


	l32i.n a0, a1, 0
	l32i.n a2, a1, 4
	l32i.n a3, a1, 8
	l32i.n a4, a1, 12
	addi a1, a1, 68
	ret
*/
